
// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "cutterbindings_python.h"

// main header
#include "basicinstructionhighlighter_wrapper.h"

// Argument includes
#include <qcolor.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_BasicInstructionHighlighter_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(args)
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::BasicInstructionHighlighter >()))
        return -1;

    ::BasicInstructionHighlighter *cptr{};
    static const char fullName[] = "CutterBindings.BasicInstructionHighlighter.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // BasicInstructionHighlighter()
            cptr = new ::BasicInstructionHighlighter();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::BasicInstructionHighlighter >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_BasicInstructionHighlighterFunc_clear(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::BasicInstructionHighlighter *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_BASICINSTRUCTIONHIGHLIGHTER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "CutterBindings.BasicInstructionHighlighter.clear";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "clear", 2, 2, &(pyArgs[0]), &(pyArgs[1])) == 0)
        return {};


    // Overloaded function decisor
    // 0: BasicInstructionHighlighter::clear(qulonglong,qulonglong)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))) {
        overloadId = 0; // clear(qulonglong,qulonglong)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);

        if (Shiboken::Errors::occurred() == nullptr) {
            // clear(qulonglong,qulonglong)
            cppSelf->clear(cppArg0, cppArg1);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_BasicInstructionHighlighterFunc_highlight(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::BasicInstructionHighlighter *>(Shiboken::Conversions::cppPointer(SbkCutterBindingsTypes[SBK_BASICINSTRUCTIONHIGHLIGHTER_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "CutterBindings.BasicInstructionHighlighter.highlight";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr, nullptr, nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "highlight", 3, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])) == 0)
        return {};


    // Overloaded function decisor
    // 0: BasicInstructionHighlighter::highlight(qulonglong,qulonglong,QColor)
    if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<unsigned long long>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QCOLOR_IDX], (pyArgs[2])))) {
        overloadId = 0; // highlight(qulonglong,qulonglong,QColor)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(args, fullName, errInfo);

    // Call function/method
    {
        unsigned long long cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);
        unsigned long long cppArg1;
        pythonToCpp[1](pyArgs[1], &cppArg1);
        if (!Shiboken::Object::isValid(pyArgs[2]))
            return {};
        ::QColor cppArg2;
        pythonToCpp[2](pyArgs[2], &cppArg2);

        if (Shiboken::Errors::occurred() == nullptr) {
            // highlight(qulonglong,qulonglong,QColor)
            cppSelf->highlight(cppArg0, cppArg1, cppArg2);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}


static const char *Sbk_BasicInstructionHighlighter_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_BasicInstructionHighlighter_methods[] = {
    {"clear", reinterpret_cast<PyCFunction>(Sbk_BasicInstructionHighlighterFunc_clear), METH_VARARGS, nullptr},
    {"highlight", reinterpret_cast<PyCFunction>(Sbk_BasicInstructionHighlighterFunc_highlight), METH_VARARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_BasicInstructionHighlighter_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_BasicInstructionHighlighter_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_BasicInstructionHighlighter_Type = nullptr;
static PyTypeObject *Sbk_BasicInstructionHighlighter_TypeF(void)
{
    return _Sbk_BasicInstructionHighlighter_Type;
}

static PyType_Slot Sbk_BasicInstructionHighlighter_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_BasicInstructionHighlighter_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_BasicInstructionHighlighter_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_BasicInstructionHighlighter_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_BasicInstructionHighlighter_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_BasicInstructionHighlighter_spec = {
    "1:CutterBindings.BasicInstructionHighlighter",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_BasicInstructionHighlighter_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void BasicInstructionHighlighter_PythonToCpp_BasicInstructionHighlighter_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_BasicInstructionHighlighter_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_BasicInstructionHighlighter_PythonToCpp_BasicInstructionHighlighter_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_BasicInstructionHighlighter_TypeF()))
        return BasicInstructionHighlighter_PythonToCpp_BasicInstructionHighlighter_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *BasicInstructionHighlighter_PTR_CppToPython_BasicInstructionHighlighter(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::BasicInstructionHighlighter *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_BasicInstructionHighlighter_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *BasicInstructionHighlighter_SignatureStrings[] = {
    "CutterBindings.BasicInstructionHighlighter(self)",
    "CutterBindings.BasicInstructionHighlighter.clear(self,address:unsigned long long,size:unsigned long long)",
    "CutterBindings.BasicInstructionHighlighter.highlight(self,address:unsigned long long,size:unsigned long long,color:typing.Union[PySide6.QtGui.QColor, PySide6.QtGui.QRgba64, QVariant, PySide6.QtCore.Qt.GlobalColor, QString, unsigned int])",
    nullptr}; // Sentinel

void init_BasicInstructionHighlighter(PyObject *module)
{
    _Sbk_BasicInstructionHighlighter_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "BasicInstructionHighlighter",
        "BasicInstructionHighlighter*",
        &Sbk_BasicInstructionHighlighter_spec,
        &Shiboken::callCppDestructor< ::BasicInstructionHighlighter >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_BasicInstructionHighlighter_TypeF(); // references _Sbk_BasicInstructionHighlighter_Type
    InitSignatureStrings(pyType, BasicInstructionHighlighter_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_BasicInstructionHighlighter_PropertyStrings);
    SbkCutterBindingsTypes[SBK_BASICINSTRUCTIONHIGHLIGHTER_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        BasicInstructionHighlighter_PythonToCpp_BasicInstructionHighlighter_PTR,
        is_BasicInstructionHighlighter_PythonToCpp_BasicInstructionHighlighter_PTR_Convertible,
        BasicInstructionHighlighter_PTR_CppToPython_BasicInstructionHighlighter);

    Shiboken::Conversions::registerConverterName(converter, "BasicInstructionHighlighter");
    Shiboken::Conversions::registerConverterName(converter, "BasicInstructionHighlighter*");
    Shiboken::Conversions::registerConverterName(converter, "BasicInstructionHighlighter&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::BasicInstructionHighlighter).name());

    qRegisterMetaType< ::BasicInstructionHighlighter *>();
}
