

#ifndef SBK_CUTTERBINDINGS_PYTHON_H
#define SBK_CUTTERBINDINGS_PYTHON_H

//workaround to access protected functions
#define protected public

#include <sbkpython.h>
#include <sbkconverter.h>
// Module Includes
#include <pyside6_qtcore_python.h>
#include <pyside6_qtgui_python.h>
#include <pyside6_qtwidgets_python.h>

// Bound library includes
#include <AddressableItemContextMenu.h>
#include <BasicBlockHighlighter.h>
#include <BasicInstructionHighlighter.h>
#include <Configuration.h>
#include <Cutter.h>
#include <CutterDockWidget.h>
#include <CutterPlugin.h>
#include <MainWindow.h>
// Conversion Includes - Primitive Types
#include <QAnyStringView>
#include <qbytearrayview.h>
#include <qchar.h>
#include <QString>
#include <QStringList>
#include <QStringView>
#include <qvariant.h>

// Conversion Includes - Container Types
#include <QHash>
#include <QList>
#include <QMap>
#include <QMultiHash>
#include <QMultiMap>
#include <QPair>
#include <QQueue>
#include <QSet>
#include <QStack>
#include <array>
#include <list>
#include <map>
#include <utility>
#include <unordered_map>
#include <vector>

// Type indices
enum : int {
    SBK_ADDRESSABLEITEMCONTEXTMENU_IDX                       = 0,
    SBK_BASICBLOCKHIGHLIGHTER_IDX                            = 1,
    SBK_BASICINSTRUCTIONHIGHLIGHTER_IDX                      = 2,
    SBK_CONFIGURATION_IDX                                    = 3,
    SBK_CUTTERCORE_IDX                                       = 4,
    SBK_CUTTERDOCKWIDGET_IDX                                 = 5,
    SBK_CUTTERPLUGIN_IDX                                     = 6,
    SBK_MAINWINDOW_MENUTYPE_IDX                              = 9,
    SBK_MAINWINDOW_CONTEXTMENUTYPE_IDX                       = 8,
    SBK_MAINWINDOW_IDX                                       = 7,
    SBK_CutterBindings_IDX_COUNT                             = 10
};
// This variable stores all Python types exported by this module.
extern PyTypeObject **SbkCutterBindingsTypes;

// This variable stores the Python module object exported by this module.
extern PyObject *SbkCutterBindingsModuleObject;

// This variable stores all type converters exported by this module.
extern SbkConverter **SbkCutterBindingsTypeConverters;

// Converter indices
enum : int {
    SBK_CUTTERBINDINGS_QLIST_INT_IDX                         = 0, // QList<int>
    SBK_CUTTERBINDINGS_QLIST_QDOCKWIDGETPTR_IDX              = 1, // QList<QDockWidget*>
    SBK_CUTTERBINDINGS_QMAP_QSTRING_QVARIANT_IDX             = 2, // QMap<QString,QVariant>
    SBK_CUTTERBINDINGS_QLIST_QOBJECTPTR_IDX                  = 3, // QList<QObject*>
    SBK_CUTTERBINDINGS_QLIST_QBYTEARRAY_IDX                  = 4, // QList<QByteArray>
    SBK_CUTTERBINDINGS_QLIST_QSTRING_IDX                     = 5, // QList<QString>
    SBK_CUTTERBINDINGS_QLIST_UNSIGNEDLONGLONG_IDX            = 6, // QList<unsigned long long>
    SBK_CUTTERBINDINGS_QHASH_QSTRING_QCOLOR_IDX              = 7, // QHash<QString,QColor>
    SBK_CUTTERBINDINGS_QLIST_QACTIONPTR_IDX                  = 8, // QList<QAction*>
    SBK_CUTTERBINDINGS_QLIST_QVARIANT_IDX                    = 9, // QList<QVariant>
    SBK_CutterBindings_CONVERTERS_IDX_COUNT                  = 10
};
// Macros for type check

QT_WARNING_PUSH
QT_WARNING_DISABLE_DEPRECATED
namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
template<> inline PyTypeObject *SbkType< ::AddressableItemContextMenu >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_ADDRESSABLEITEMCONTEXTMENU_IDX]); }
template<> inline PyTypeObject *SbkType< ::BasicBlockHighlighter >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_BASICBLOCKHIGHLIGHTER_IDX]); }
template<> inline PyTypeObject *SbkType< ::BasicInstructionHighlighter >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_BASICINSTRUCTIONHIGHLIGHTER_IDX]); }
template<> inline PyTypeObject *SbkType< ::Configuration >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CONFIGURATION_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterCore >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERCORE_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterDockWidget >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERDOCKWIDGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::CutterPlugin >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_CUTTERPLUGIN_IDX]); }
template<> inline PyTypeObject *SbkType< ::MainWindow::MenuType >() { return SbkCutterBindingsTypes[SBK_MAINWINDOW_MENUTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::MainWindow::ContextMenuType >() { return SbkCutterBindingsTypes[SBK_MAINWINDOW_CONTEXTMENUTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::MainWindow >() { return reinterpret_cast<PyTypeObject *>(SbkCutterBindingsTypes[SBK_MAINWINDOW_IDX]); }

} // namespace Shiboken

QT_WARNING_POP
#endif // SBK_CUTTERBINDINGS_PYTHON_H

