#ifndef SBK_CUTTERCOREWRAPPER_H
#define SBK_CUTTERCOREWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <Cutter.h>

namespace PySide { class DynamicQMetaObject; }

class CutterCoreWrapper : public CutterCore
{
public:
    CutterCoreWrapper(const CutterCoreWrapper &) = delete;
    CutterCoreWrapper& operator=(const CutterCoreWrapper &) = delete;
    CutterCoreWrapper(CutterCoreWrapper &&) = delete;
    CutterCoreWrapper& operator=(CutterCoreWrapper &&) = delete;

    CutterCoreWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~CutterCoreWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_CUTTERCOREWRAPPER_H

