#ifndef SBK_CUTTERPLUGINWRAPPER_H
#define SBK_CUTTERPLUGINWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <CutterPlugin.h>

class CutterPluginWrapper : public CutterPlugin
{
public:
    CutterPluginWrapper(const CutterPluginWrapper &) = delete;
    CutterPluginWrapper& operator=(const CutterPluginWrapper &) = delete;
    CutterPluginWrapper(CutterPluginWrapper &&) = delete;
    CutterPluginWrapper& operator=(CutterPluginWrapper &&) = delete;

    CutterPluginWrapper();
    ::QString getAuthor() const override;
    ::QString getDescription() const override;
    ::QString getName() const override;
    ::QString getVersion() const override;
    void registerDecompilers() override;
    void setupInterface(::MainWindow * main) override;
    void setupPlugin() override;
    void terminate() override;
    ~CutterPluginWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#endif // SBK_CUTTERPLUGINWRAPPER_H

